import bpy
from bpy.app.handlers import persistent

def setDefaultCollectionValue():
    myCollection = bpy.context.scene.Cinepack.camera_move_collection
    # set default value if <myCollection> is empty
    # print(myCollection,len(myCollection))
    if not (myCollection and len(myCollection)):
        # print(Scene.cinepack_data.camera_moves_dict)
        for cat_name,moves in bpy.context.scene.cinepack_data.camera_moves_dict.items():
            for move_name,move_path in moves:
                collectionItem = myCollection.add()
                collectionItem.name = move_name
                collectionItem.category = cat_name

# This handler is needed to set the default value for <bpy.context.scene.myCollection>
# right after the addon registration via register()
@persistent
def onRegister_fillCollection(scene): #here scene is dummy 
    print("deps_update_post : Fill Collection")
    myCollection = bpy.context.scene.Cinepack.camera_move_collection
    setDefaultCollectionValue()

    #check if handler is needed or not by checking if collection has data
    if len(myCollection)>0:
        # the handler isn't needed anymore, so remove it
        bpy.app.handlers.depsgraph_update_post.remove(onRegister_fillCollection)

@persistent
def onFileLoaded_fillCollection(scene):
    print("Load post handler : Fill Collection")
    setDefaultCollectionValue()


@persistent
def onRegister_setcategory(scene): #here scene is dummy 
    print("deps_update_post : Set Category")
    cp_props = bpy.context.scene.Cinepack
    if not cp_props.categories:
        cp_props.categories = {'Chaotic'}
        print("Setting Category Value to ", 'Chaotic')
    bpy.app.handlers.depsgraph_update_post.remove(onRegister_setcategory)

@persistent
def onFileLoaded_setCategory(scene):
    print("Load post handler : Set category")
    cp_props = bpy.context.scene.Cinepack
    if not cp_props.categories:
        cp_props.categories = {'Chaotic'}
        print("Setting Category Value to ", 'Chaotic')

def register():
    bpy.app.handlers.load_post.append(onFileLoaded_fillCollection)
    bpy.app.handlers.load_post.append(onFileLoaded_setCategory)
    bpy.app.handlers.depsgraph_update_post.append(onRegister_fillCollection)
    bpy.app.handlers.depsgraph_update_post.append(onRegister_setcategory)

def unregister():
    bpy.app.handlers.load_post.remove(onFileLoaded_fillCollection)
    bpy.app.handlers.load_post.remove(onFileLoaded_setCategory)
    pass
