import bpy,os
from bpy.types import AddonPreferences,Scene
from bpy.props import EnumProperty, StringProperty

class CinePackPreferences(AddonPreferences):
    print(__package__)
    bl_idname = __package__


    filepath : StringProperty(
        name = "CinePack Folder",
        subtype = "DIR_PATH"
    )

    ext_img_editor : StringProperty(
        name = "External Image Editor",
        description = "Select Image editor in which gif previews will be opened",
        subtype = "FILE_PATH",
    )

    ui_layout : EnumProperty(items=[('VISUAL','VISUAL','VISUAL'),('COMPACT','COMPACT','COMPACT')],
                default='COMPACT',name='UI Layout',description='UI Layout for add-on')
                
    def draw(self,context):
        layout = self.layout
        row = layout.row()
        row.label(text="Select Cinepack Folder")
        row.prop(self,"filepath" , text = "")
        row = layout.row()
        row.label(text="External Image Editor")
        row.prop(self,"ext_img_editor" , text = "")
        row = layout.row()
        row.prop(self,"ui_layout",expand = True)

classes = [CinePackPreferences]

def register():
    for cls in classes:
        bpy.utils.register_class(cls)

def unregister():
    for cls in reversed(classes):
        bpy.utils.unregister_class(cls)
